<template>
  <v-container fluid>
    <v-layout row wrap justify-center align-center>

      <v-flex xs12>
        <h1 class="text-lg-center">Todolist App</h1>
      </v-flex>

      <v-flex xs12>
        <v-card class="mt-5 mr-5 ml-5 mb-5 elevation-12" flat>
          <v-container fluid>
          <v-timeline dense clipped>

            <v-timeline-item
              fill-dot
              class="white--text mb-2 mt-5"
              color="orange"
              large>
              <span slot="icon">U</span>

              <v-text-field
                v-model="input"
                hide-details
                outline
                label="Nouvel élément..."
                solo
                @keydown.enter="comment('user')">
                <template slot="append">
                  <div>
                    <v-btn
                      class="mx-0"
                      depressed
                      icon
                      :disabled="!input || isLoading.commentBtn"
                      @click="comment('user')">
                      <v-progress-circular
                        v-if="isLoading.commentBtn"
                        indeterminate
                        size="28"
                        color="primary">
                      </v-progress-circular>
                      <v-icon v-else>send</v-icon>
                    </v-btn>
                  </div>
                </template>
              </v-text-field>
            </v-timeline-item>

            <v-scroll-x-transition group class="mt-2">
              <v-timeline-item
                v-for="(message, index) in messages"
                :key="`message-${index}`"
                class="mb-3"
                :color="'pink'"
                small>
                <v-layout justify-space-between>
                  <v-flex xs7><div class="subheading">{{message.content}}</div></v-flex>
                  <v-flex xs5 text-xs-right>{{fromNowFormatter(message.date)}}</v-flex>
                  <v-btn @click="deleteItem(message)">Supprimer</v-btn>
                </v-layout>
              </v-timeline-item>
            </v-scroll-x-transition>

          </v-timeline>
          </v-container>
        </v-card>
      </v-flex>
    </v-layout>

  </v-container>
</template>

<script>
  // Components
  import ProgressCircle from '../components/ProgressCircle'

  // Mixins
  import formatterMixin from '../mixins/formatter'

export default
{
  name: 'Home',

  mixins: [formatterMixin],

  components:
  {
    ProgressCircle
  },

  data()
  {
    return {
      isLoading: {commentBtn: false},
      items: [],
      input: null
    }
  },

  created()
  {
    this.getItems();
    console.log(process.env.VUE_APP_API_URL);
  },

  methods:
  {
    getItems()
    {
      this.$http
      .get('/')
      .then(res =>
      {
        this.items = res.data.items;
      })
      .catch(err =>
      {
        // TODO : Catch error
      })
    },

    comment()
    {
      this.isLoading.commentBtn = true;

      this.$http
      .post('/', {content: this.input})
      .then(res =>
      {
        this.items.push(res.data);
        this.isLoading.commentBtn = false;
        this.input = null;
      })
      .catch(err =>
      {
        // TODO : Catch error
      })
    },

    deleteItem(item)
    {
      this.$http
      .delete(`/${item._id}`)
      .then(res =>
      {
        this.items = this.items.filter(val => val._id !== item._id);
      })
      .catch(err =>
      {
        // TODO : Catch error
      })
    }
  },

  computed:
  {
    messages()
    {
      return this.items.slice().reverse();
    }
  }
}
</script>
<style scoped>
</style>